                                                  
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  '512x384
  '16 x 12
  tiles = gr#tiles

  cols = 16
  rows = 12

  pixels_col =  512 / 16
  pixels_row =  384 / 12

  adrs = 1 
  chr = 0

  maskSetDDRAMadrs = $80
  instrSetDDRAMadrs = $80

  instrSetCGRAMadrs = $40
  maskSetCGRAMadrs  = $c0

  instrFuncSet           = $20
  maskFuncSet            = $e0
  eithtBitMode           = $10
  twoLines               = $08                                  
  largeFont              = $04
                      
  instrCursorDisplay     = $10               
  maskCursorDisplay      = $f0           
  shiftOrCursorMove = $8
  rightLeft = $4

  instrEntryMode = $04  
  maskEntryMode  = $fc   
  incCursorPos   = $02  
  scrollDisp     = $01

  instrDisplayCtrl   = $08   
  maskDisplayCtrl  = $f8      
  displayOn        = $04   
  cursorOn         = $02   
  blinkOn          = $01   

  instrCursorHome   = $02   
  maskCursorHome  = $fe    

  instrClearDisplay  = $01
  maskClearDisplay = $ff

  width_font = 1

  

OBJ
  gr    :  "vga graphics ASM"

VAR

  BYTE DDRAM[104]
  BYTE CGRAM[64]

  BYTE lastAdrsSet

  LONG RL,ID

  BYTE DL,N,F,D,C,RANGE,dispBlanked,SC,B,S,AC

  LONG shiftChars

  BYTE currDispChrs_adrs[32]
  BYTE currDispChrs_chr[32]

  BYTE prevDDRAMadrCursAt
  BYTE cursPos
  BYTE cursOutOfDisp
  BYTE undCursClrd

  BYTE upNib
  BYTE lowNib
  BYTE gotUpNib

  BYTE ACmn64

  BYTE CARACTER

  WORD pos_x, pos_y, pos_table_character,pos_x_c,pos_y_c,pos_c

  BYTE blinkChar
  BYTE blinked 

'0x80, 0xC0, 0xA0, and 0xE0

  LONG SECONDS

PUB MainLoop|h,i,deg,x,y,mask,ii,char

    prevDDRAMadrCursAt:= 0
    cursPos:= 0
    cursOutOfDisp:= 0
    undCursClrd:= 0

    upNib:= 0
    lowNib:= 0
    gotUpNib:= 0
    blinkChar:=$20

    DESENHA_LCD

    CFG_RESET_LCD
    PAUSE

    LCD($38,1,0,0)   '8 BITS ON, 2 LINES, 5X8 FONT
    PAUSE

    LCD($0E,1,0,0)   'DISPLAY ON, CURSOR ON, BLINK OFF
    PAUSE

    LCD($40,1,0,0)   'SET TO CGRAM
    LCD($0E,1,0,1)
    LCD($1B,1,0,1)
    LCD($11,1,0,1)
    LCD($11,1,0,1)
    LCD($11,1,0,1)   'DRAW A BATERY
    LCD($11,1,0,1)
    LCD($1F,1,0,1)
    LCD($00,1,0,1)
    LCD(14,1,0,1)
    LCD(31,1,0,1)
    LCD(30,1,0,1)
    LCD(28,1,0,1)
    LCD(24,1,0,1)
    LCD(28,1,0,1)    'DRAW PACMAN
    LCD(14,1,0,1)
    LCD(0,1,0,1)
    LCD(14,1,0,1)
    LCD(31,1,0,1)
    LCD(15,1,0,1)
    LCD(7,1,0,1)
    LCD(3,1,0,1)
    LCD(7,1,0,1)     'DRAW PACMAN COMER
    LCD(14,1,0,1)
    LCD(0,1,0,1)
    LCD($80,1,0,0)  'SET TO DDRAM


    PAUSE_1S
    PAUSE_1S
    

    LCD(1,1,0,0)              'CLEAR SCREEN
    LCD($87,1,0,0)            'CURSOR CENTRO TELA
    LCD($4,1,0,0)             'Entry mode set command 04h Decrement Address Counter Display Shift :OFF
    TEXTO(STRING("HELLO!"))
    PAUSE
    PAUSE

    LCD(1,1,0,0)              'CLEAR SCREEN
    LCD($87,1,0,0)            'CURSOR CENTRO TELA
    LCD($6,1,0,0)             'Entry mode set command 06h Display Shift :OFF Increment Address Counter
    TEXTO(STRING("HELLO!"))
    PAUSE
    PAUSE

    LCD(1,1,0,0)              'CLEAR SCREEN
    LCD(2,1,0,0)              'HOME CURSOR
    LCD($87,1,0,0)            'CURSOR CENTRO TELA
    LCD($7,1,0,0)             'Entry mode set command 07h Display Shift :ON Increment Address Counter
    TEXTO(STRING("HELLO!"))
    PAUSE
    PAUSE

    LCD(1,1,0,0)              'CLEAR SCREEN
    LCD(2,1,0,0)              'HOME CURSOR
    LCD($87,1,0,0)            'CURSOR CENTRO TELA
    LCD($5,1,0,0)             'Entry mode set command 05h Display Shift :ON Decrement Address Counter
    TEXTO(STRING("HELLO!"))
    PAUSE
    PAUSE


    LCD($6,1,0,0)             'Entry mode set command 06h Display Shift :OFF Increment Address Counter
    LCD(2,1,0,0)              'HOME CURSOR
    repeat i from 0 to 1
      LCD(1,1,0,0)              'CLEAR SCREEN
      TEXTO(STRING("TCPIPCHIP"))
      PAUSE
      PAUSE

    repeat i from 0 to 1
      LCD(1,1,0,0)              'CLEAR SCREEN
      LCD($C0,1,0,0)            'SECOND LINE
      TEXTO(STRING("BASIC4EVER"))
      PAUSE

    repeat i from 0 to 44
        LCD($1C,1,0,0) 'SHIFT RIGHT
        PAUSE

    repeat i from 0 to 44
        LCD($18,1,0,0) 'SHIFT LEFT
        PAUSE

    LCD(2,1,0,0)   'HOME CURSOR
    PAUSE

    LCD(6,1,0,0)   'SCROLL OFF, INC CURSOR

    'LCD($0B,1,0,0) 'DISPLAY OFF

    LCD(0,1,0,1)         'CGRAM 0
    LCD(1,1,0,1)         'CGRAM 1
    LCD(2,1,0,1)         'CGRAM 2

    repeat i from 170 TO 180
        LCD(i,1,0,1) 'ROM HITACHI EMULATION

    repeat i from 0 to 15 
      LCD($1C,1,0,0) 'SHIFT RIGHT
    repeat i from 0 to 15
      LCD($18,1,0,0) 'SHIFT LEFT

    repeat i from 0 to 15 
      LCD($1C,1,0,0) 'SHIFT RIGHT
      LCD($18,1,0,0) 'SHIFT LEFT

    LCD($1C,1,0,0) 'SHIFT RIGHT

    PAUSE_1S
    PAUSE_1S

   'LCD($0C,1,0,0)   'CURSOR OFF
    LCD($0F,1,0,0)    'CURSOR ON

     LCD($3C,1,0,0) 'BIG FONT

     repeat i from 0 to 15 
        LCD($1C,1,0,0) 'SHIFT RIGHT
        LCD($18,1,0,0) 'SHIFT LEFT

     'LCD($38,1,0,0) 'LITTLE FONT

     LCD($18,1,0,0) 'SHIFT LEFT
     LCD($85,1,0,0)  'COL 5 CURSOR, LINE 1

     LCD($6,1,0,0)   'Display Shift :OFF Increment Address Counter

     repeat 1==1
         seconds++
        'LCD($1C,1,0,0) 'SHIFT RIGHT
        'LCD($18,1,0,0) 'SHIFT LEFT
        if seconds>20000
           seconds := 0
           blinkcur
           LCD($16,1,0,0) '  AVANA CURSOR DIREITA


            
PUB LCD(data,eGoLow,rwState,rsState)
        if(eGoLow == 1) ' E goes LOW, this is when instructions are evaluated, chars written
                if(rsState == 0 AND rwState == 0)
                        if(DL == 1)
                                evalInstr(data)
                        else       
                                if(gotUpNib == 0)
                                        upNib:= data
                                        gotUpNib:= 1
                                        'instrpeek(instr) 'REVERRRRRRRRRRRR
                                else
                                        lowNib:= data
                                        gotUpNib:= 0
                                        evalInstr((upNib << 4) | lowNib)                        
                
                if(rsState == 1 AND rwState == 0)
                        if(DL == 1)
                                writeData(data)
                        else
                                if(gotUpNib == 0)
                                        upNib:= data
                                        gotUpNib:= 1
                                        'instrpeek(instr) REVEEEEEEEEEEEEEEEER                                
                                else
                                        lowNib:= data
                                        gotUpNib:= 0
                                        writeData((upNib << 4) | lowNib)
                updateStats                        
                return



PUB evalInstr(instr) | i
        if((instr & maskSetDDRAMadrs) == instrSetDDRAMadrs)                                
                setDDRadrs(instr & $7f)
                lastAdrsSet := "D"
                return
        
        
        if((instr & maskSetCGRAMadrs) == instrSetCGRAMadrs)
                AC := (instr & $3f)+64
                updateUndCurs
                lastAdrsSet := "C"
                return
        
        if((instr & maskFuncSet) == instrFuncSet)
                if(instr & eithtBitMode)
                        if(DL == 0)
                                DL:= 1                        
                        DL := 1
                else
                        if((gotUpNib == 0) AND (DL==1))
                                upNib:= instr >> 4
                                gotUpNib := 1
                                instr := instr >> 4
                                DL:= 0                

                if(instr & twoLines)
                        repeat i from 0 to 31            
                           pchar(32,i)
                        repeat i from 0 to 31                        
                           pchar(32,i)                        
                        N:= 1
                        range:= 32
                        updateDisp
                
                else
                        repeat i from 0 to 15                         
                            pchar(32,i)
                        N := 0
                        range := 16
                        updateDisp
                
                if(instr & largeFont)
                        F := 1                
                else
                        F := 0
                        
                return
        
        if((instr & maskCursorDisplay) == instrCursorDisplay)
                if(instr & rightLeft)
                        RL:= 1
                else
                        RL:= -1
                
                if(instr & shiftOrCursorMove)
                        SC := 1       
                        shiftChars := shiftchars - RL
                        lastAdrsSet := "D"
                        updateDisp                
                else
                        SC := 0
                        lastAdrsSet := "D"
                        incdcrDDRadrs(RL)
                        updateDisp
                

                return
        
        
        if((instr & maskEntryMode) == instrEntryMode)
                if(instr & incCursorPos)
                        ID := 1
                else
                        ID := -1 
                
                
                if(instr & scrollDisp)
                        S := 1
                else
                        S := 0                
                
                return
      
        
        if((instr & maskDisplayCtrl) == instrDisplayCtrl)
                if(instr & displayOn)
                        D:= 1
                        dispBlanked := 0
                        updateDisp
                else
                        D:= 0
                        updateDisp
                
                if(instr & cursorOn)
                        C:= 1
                        updateUndCurs
                else
                        C := 0
                        updateUndCurs
                
                if(instr & blinkOn)
                        B := 1
                
                else
                        B := 0
                
                return
        
        
        
        if((instr & maskClearDisplay) == instrClearDisplay)
                repeat i from 0 to 103
                        DDRAM[i]:=$20
                repeat i from 0 to 31
                        pchar(32,i)
                ID := 1
                setDDRadrs(0)
                lastAdrsSet := "D"
                updateDisp
                
                return
        

        if((instr & maskCursorHome) == instrCursorHome)
                shiftChars := 0
                setDDRadrs(0)
                lastAdrsSet := "D"
                updateDisp
                
                return
        
        
        return


PUB writedata(data)
        if(lastAdrsSet == "D")
                DDRAM[AC] := data
                if(S)
                    shiftChars := shiftChars + ID
                incdcrDDRadrs(ID) 
                UpdateDisp
        
        else
                CGRAM[AC//64] := data
                ACmn64 := AC // 64
                incdcrCGRadrs(ID)  
                cgramChanged   


PUB CFG_RESET_LCD | i
    lastAdrsSet:="D"
    AC:=0   '  Ponteiro DDRAM
    range:= 16 ' 16 chars only

    'function set
    DL:= 1  '  8-bit interface data
    N := 0  '  1-line display
    F := 0  '5 * 8 dot character font
    '//Display on/off control:
    D:= 0   ' Display off
    C:= 0   ' Cursor off
    B:= 0   'Blinking off
    'Entry mode set:
    ID:= 1  '  Increment by 1
    S:= 0   '  No shift
    'Cursor or display shift command:
    RL:= 1           'RIGHT LEFT
    SC:= 0           'SHIFT OR CURSOR MOVE
    'Blink off
    Blinked:=0
    Seconds:=0
    'BLANK DISPLAY
    dispBlanked:=0

    repeat i from 0 to 103 'LINHAS DA DDRAM
      DDRAM[i]:=$20

    repeat i from 0 to 63 'CGRAM
      CGRAM[i]:=0

    shiftChars:= 0

    initCurrDispChrs

    updateDisp

    blinkCur

    updateStats

PUB DESENHA_LCD | i

    gr.start

    gr.pointcolor(1)

    repeat i from 0 to tiles - 1                        'init tile colors to white on black
      gr.color(i,$FF00)
      'gr.color(i,$FF<<8|i*4)                            'init tile colors "Nice view"

    gr.text(1*pixels_col,0*pixels_row,string(" HITACHI LCD BRIDGE 2X16"))

    gr.box(2*pixels_col,4*pixels_row,13*pixels_col,7*pixels_row)                               'draw a box
    gr.box(1*pixels_col,3*pixels_row,14*pixels_col,8*pixels_row)                               'draw a box

    repeat i from 66 to 66+10                        'init tile colors to white on black
      gr.color(i,$FF<<8| 8 *4)                                   'init tile colors "Nice view"

    repeat i from 82 to 82+10                        'init tile colors to white on black
      gr.color(i,$FF<<8| 8 *4)                                   'init tile colors "Nice view"

    repeat i from 98 to 98+10                        'init tile colors to white on black
      gr.color(i,$FF<<8| 8 *4)                                   'init tile colors "Nice view"



PUB setDDRadrs(address)
        AC:= address
        if(N==0)
           if(AC > 79)
              AC:= 0
        else
            if(AC > 64)
                if(AC > 39 AND AC < 64)
                   AC:= 64
                if(AC > 103)
                   AC:= 0
        updateUndCurs


PUB   incdcrDDRadrs(incordcr)
      IF N==0
         AC:=AC+incordcr
         IF AC<0
            AC:=79
         AC:= AC // 80
      ELSE        
        AC:=AC+incordcr 
        IF AC<0
           AC:=103
        IF(AC > 39 AND AC < 64)
           AC:= 64
        IF AC> 103
           AC:=0


PUB initCurrDispChrs | i
    repeat i from 0 to 15 
           currDispChrs_chr[i]:= $20
           currDispChrs_adrs[i]:=  i

    repeat i from 16 to 31 
           currDispChrs_chr[i]:= $20
           currDispChrs_adrs[i]:=  48 + i

PUB  updateDisp | ln
      setCurrDispChrs
      if(D==0)
          if(dispBlanked <> 1)
             blankDisp
          return
          
      if(N == 0)
         if ((shiftChars > 79) OR (shiftChars < -79))
             shiftChars:=0
      else
         if((shiftChars > 39) OR (shiftChars < -39))
            shiftChars:=0

      if(N == 0)
          repeat ln from 0 to 15 
             if currDispChrs_chr[ln] <> DDRAM[currDispChrs_adrs[ln]]
                                pchar(DDRAM[currDispChrs_adrs[ln]],ln)
                                currDispChrs_chr[ln] := DDRAM[currDispChrs_adrs[ln]]
      else
          repeat ln from 0 to 31 
             if currDispChrs_chr[ln] <> DDRAM[currDispChrs_adrs[ln]]
                                pchar(DDRAM[currDispChrs_adrs[ln]],ln)
                                currDispChrs_chr[ln] := DDRAM[currDispChrs_adrs[ln]]

'these are to clear the cursor trace in case of LCD scroll*/

      pchar(currDispChrs_chr[0],0)
      pchar(currDispChrs_chr[15],15)
      if(range == 32)
          pchar(currDispChrs_chr[16],16)
          pchar(currDispChrs_chr[31],31)
           
      updateUndCurs

PUB  setCurrDispChrs | i
     IF N==0
        repeat i from 0 to 15
          currDispChrs_adrs[i]:= (i + 80 + shiftChars) // 80                            'adrs
     ELSE
        repeat i from 0 to 15
          currDispChrs_adrs[i]:= (i + 40 + shiftChars) // 40                            'adrs

        repeat i from 16 to 31
          if(shiftChars < 0)
              currDispChrs_adrs[i]:= (i + 40 + shiftChars + 48) 'adrs
              if(currDispChrs_adrs[i] > 103)
                currDispChrs_adrs[i]:= (currDispChrs_adrs[i] // 104) + 64
          else
                 currDispChrs_adrs[i]:= i  + shiftChars + 48     'adrs
                 if(currDispChrs_adrs[i] > 103)
                    currDispChrs_adrs[i]:= (currDispChrs_adrs[i] // 104) + 64

'analisar quem apaga cursor apos imprimer T
PUB blankDisp | i, ln

        repeat i from 0 to range - 1
              pcursor(i,0)

        repeat i from 0 to 31
                        pchar(32,i)

        repeat ln from 0 to 31
              currDispChrs_chr[ln] := $20
              
        dispBlanked := 1

PUB incdcrCGRadrs(incordcr)
        AC:= AC + incordcr
        if(AC-64 < 0)
          AC:= 63
        if(AC-64 > 63)
          AC:= 0


PUB cgramchanged | i
        if(D == 1)
                repeat i from 0 to range-1
                    if(currDispChrs_chr[i] < 8)
                       caracter:=currDispChrs_chr[i]
         updateUndCurs

PUB DEBUG
    gr.pointcolor(1)
    gr.text(0,0,string("EMULADOR DE LCD HITACHI 1.0"))
    'gr.text(0*pixels_col,0*pixels_row,@DDRAM)

PUB pchar(chrnum,pos) | ind_table_character, char, bit
    pcursor(pos,0)
    pos_table_character := chrnum * 7
    repeat ind_table_character from 0 to 6
        if chrnum > 7
           char := HITACHI_CHARACTER[pos_table_character+ind_table_character]  'rom font (emulator)
        else
           char := CGRAM[(chrnum*8)+ind_table_character] 'cgram
        char := char << 3
        repeat bit from 0 to 4
          gr.pointcolor((char & $80)>0)
          gr.boxfill(pos_y,pos_x,pos_y + width_font + f, pos_x + width_font + f)
          char := char << 1
          pos_y := pos_y + 4
      pos_y := pos_c
      pos_x := pos_x + 4


PUB pcursor(pos,On_Off) | i
    if pos < 16                  'PRIMEIRA LINHA
       pos_x := 4 * (pixels_row+40)/2
       pos_x_c := (4 *(pixels_row+40)/2) + 29           'CURSOR
    else
       pos_x := (5 * (pixels_row+36)/2) + 12               'SEGUNDA LINHA + ESPACO CURSOR
       pos_x_c := (5 *(pixels_row+40)/2) + 31           'SEGUNDA LINHA
       pos := pos - 16           'DDR 0..15 LINE 1, 16..32 LINE 2

    pos:=pos+3  'AJUSTE DESENHO LCD
    pos := pos *  (pixels_col+12)/2 'AJUSTE DESENHO LCD  (2 CHARACTERES POR TILE)
    pos_y :=  pos 

    pos_c := pos      'SALVA POS PARA PCHAR
    pos_y_c := pos

    repeat i from 0 to 4
       gr.pointcolor(On_Off)
       gr.boxfill(pos_y_c,pos_x_c,pos_y_c + width_font, pos_x_c + width_font)
       pos_y_c := pos_y_c + 4


PUB updateUndCurs | i
        cursOutOfDisp := 1
        if(D == 1)
                repeat i from 0 to range-1
                        if(currDispChrs_adrs[i] == prevDDRAMadrCursAt)
                                pchar(DDRAM[currDispChrs_adrs[cursPos]],cursPos)
        else
             if(D == 0 OR ( C == 0 AND B == 0))
                pcursor(cursPos,0)
                return
        
                
        repeat i from 0 to range-1
                if(currDispChrs_adrs[i] == AC)
                        prevDDRAMadrCursAt := AC
                        cursPos := i
                        blinkChar := currDispChrs_chr[i]
                        cursOutOfDisp:= 0
        
        if(C == 1 AND cursOutOfDisp == 0)
                pcursor(cursPos,1)
                undCursClrd := 0


PUB blinkCur        
        if(B == 0 OR D == 0 OR cursOutOfDisp == 1)
                if(blinked == 1 AND cursPos < range AND cursOutOfDisp == 0)
                        pchar(blinkChar,cursPos)
                        blinked := 0
                        if(C == 1 AND cursOutOfDisp == 0)
                                'document['p'+ parseInt(cursPos * 8 + 7)].src = '31.gif'
                'setTimeout("blinkCur()",379)
                return
        if(blinked == 1)
                pchar(blinkChar,cursPos)
                blinked := 0
                'setTimeout("blinkCur()",379)
                if(C == 1 AND cursOutOfDisp == 0)
                                'document['p'+ parseInt(cursPos * 8 + 7)].src = '31.gif'
        else 
                pchar(255,cursPos)
                'document['p'+ parseInt(cursPos * 8 + 7)].src = '31.gif'
                blinked := 1
                'setTimeout("blinkCur()",379)

PUB updateStats | i
        cursOutOfDisp := 1
        repeat i from 0 to range-1
                if(currDispChrs_Adrs[i] == AC)
                        cursOutOfDisp := 0


PUB PAUSE
       RETURN
       waitcnt(clkfreq / 10 + cnt)

PUB PAUSE_1S
       waitcnt(clkfreq + cnt)
  

PUB Texto(Address) | i,caract                      'Place a text string from the ROM table at offset location offsetX,offsetY
    i := 0
    repeat 
      caract:=byte[Address + i]
       i++       
      if caract <> 0
         LCD(caract,1,0,1)
      else
         quit

DAT
HITACHI_CHARACTER
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 4, 4, 4, 4, 4, 0, 4
BYTE 10,10,10, 0, 0, 0, 0
BYTE 10,10,31,10,31,10,10
BYTE 4,15,20,14, 5,30, 4
BYTE 24,25, 2, 4, 8,19, 3
BYTE 12,18,20, 8,21,18,13
BYTE 12, 4, 8, 0, 0, 0, 0
BYTE 2, 4, 8, 8, 8, 4, 2
BYTE 8, 4, 2, 2, 2, 4, 8
BYTE 0, 4,21,14,21, 4, 0
BYTE 0, 4, 4,31, 4, 4, 0
BYTE 0, 0, 0, 0,12, 4, 8
BYTE 0, 0, 0,31, 0, 0, 0
BYTE 0, 0, 0, 0, 0,12,12
BYTE 0, 1, 2, 4, 8,16, 0
BYTE 14,17,19,21,25,17,14
BYTE 4,12, 4, 4, 4, 4,14
BYTE 14,17, 1, 2, 4, 8,31
BYTE 31, 2, 4, 2, 1,17,14
BYTE 2, 6,10,18,31, 2, 2
BYTE 31,16,30, 1, 1,17,14
BYTE 6, 8,16,30,17,17,14
BYTE 31, 1, 2, 4, 8, 8, 8
BYTE 14,17,17,14,17,17,14
BYTE 14,17,17,15, 1, 2,12
BYTE 0,12,12, 0,12,12, 0
BYTE 0,12,12, 0,12, 4, 8
BYTE 2, 4, 8,16, 8, 4, 2
BYTE 0, 0,31, 0,31, 0, 0
BYTE 16, 8, 4, 2, 4, 8,16
BYTE 14,17, 1, 2, 4, 0, 4
BYTE 14,17, 1,13,21,21,14
BYTE 14,17,17,17,31,17,17
BYTE 30,17,17,30,17,17,30
BYTE 14,17,16,16,16,17,14
BYTE 30,17,17,17,17,17,30
BYTE 31,16,16,30,16,16,31
BYTE 31,16,16,30,16,16,16
BYTE 14,17,16,23,17,17,15
BYTE 17,17,17,31,17,17,17
BYTE 14, 4, 4, 4, 4, 4,14
BYTE 7, 2, 2, 2, 2,18,12 
BYTE 17,18,20,24,20,18,17
BYTE 16,16,16,16,16,16,31
BYTE 17,27,21,21,17,17,17
BYTE 17,17,25,21,19,17,17
BYTE 14,17,17,17,17,17,14
BYTE 30,17,17,30,16,16,16
BYTE 14,17,17,17,21,18,13
BYTE 30,17,17,30,20,18,17
BYTE 15,16,16,14, 1, 1,30
BYTE 31, 4, 4, 4, 4, 4, 4
BYTE 17,17,17,17,17,17,14
BYTE 17,17,17,17,17,10, 4
BYTE 17,17,17,21,21,21,10
BYTE 17,17,10, 4,10,17,17
BYTE 17,17,17,10, 4, 4, 4
BYTE 31, 1, 2, 4, 8,16,31
BYTE 14, 8, 8, 8, 8, 8,14
BYTE 17,10,31, 4,31, 4, 4
BYTE 14, 2, 2, 2, 2, 2,14
BYTE 4,10,17, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0,31
BYTE 8, 4, 2, 0, 0, 0, 0
BYTE 0, 0,14, 1,15,17,15
BYTE 16,16,22,25,17,17,30
BYTE 0, 0,14,16,16,17,14 
BYTE 1, 1,13,19,17,17,15
BYTE 0, 0,14,17,31,16,14
BYTE 6, 9, 8,28, 8, 8, 8
BYTE 0, 0,15,17,15, 1,14
BYTE 16,16,22,25,17,17,17
BYTE 4, 0,12, 4, 4, 4,14 
BYTE 2, 6, 2, 2, 2,18,12
BYTE 16,16,18,20,24,20,18
BYTE 12, 4, 4, 4, 4, 4,14
BYTE 0, 0,26,21,21,17,17
BYTE 0, 0,22,25,17,17,17
BYTE 0, 0,14,17,17,17,14
BYTE 0, 0,30,17,30,16,16
BYTE 0, 0,13,19,15, 1, 1
BYTE 0, 0,22,25,16,16,16
BYTE 0, 0,15,16,14, 1,30
BYTE 8, 8,28, 8, 8, 9, 6
BYTE 0, 0,17,17,17,19,13
BYTE 0, 0,17,17,17,10, 4
BYTE 0, 0,17,17,21,21,10
BYTE 0, 0,17,10, 4,10,17
BYTE 0, 0,17,17,15, 1,14
BYTE 0, 0,31, 2, 4, 8,31
BYTE 2, 4, 4, 8, 4, 4, 2
BYTE 4, 4, 4, 4, 4, 4, 4
BYTE 8, 4, 4, 2, 4, 4, 8
BYTE 0, 4, 2,31, 2, 4, 0
BYTE 0, 4, 8,31, 8, 4, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0, 0, 0, 0
BYTE 0, 0, 0, 0,28,20,28
BYTE 7, 4, 4, 4, 0, 0, 0
BYTE 0, 0, 0, 4, 4, 4,28
BYTE 0, 0, 0, 0,16, 8, 4
BYTE 0, 0, 0,12,12, 0, 0
BYTE 0,31, 1,31, 1, 2, 4
BYTE 0, 0,31, 1, 6, 4, 8
BYTE 0, 0, 2, 4,12,20, 4
BYTE 0, 0, 4,31,17, 1, 6
BYTE 0, 0, 0,31, 4, 4,31
BYTE 0, 0, 2,31, 6,10,18
BYTE 0, 0, 8,31, 9,10, 8
BYTE 0, 0, 0,14, 2, 2,31
BYTE 0, 0,30, 2,30, 2,30
BYTE 0, 0, 0,21,21, 1, 6
BYTE 0, 0, 0, 0,31, 0, 0
BYTE 31, 1, 5, 6, 4, 4, 8
BYTE 1, 2, 4,12,20, 4, 4
BYTE 4,31,17,17, 1, 2, 4
BYTE 0, 0,31, 4, 4, 4,31
BYTE 2,31, 2, 6,10,18, 2
BYTE 8,31, 9, 9, 9, 9,18
BYTE 4,31, 4,31, 4, 4, 4
BYTE 0,15, 9,17, 1, 2,12
BYTE 8,15,18, 2, 2, 2, 4
BYTE 0,31, 1, 1, 1, 1,31
BYTE 10,31,10,10, 2, 4, 8
BYTE 0,24, 1,25, 1, 2,28
BYTE 0,31, 1, 2, 4,10,17
BYTE 8,31, 9,10, 8, 8, 7
BYTE 0,17,17, 9, 1, 2,12
BYTE 0,15, 9,21, 3, 2,12
BYTE 2,28, 4,31, 4, 4, 8
BYTE 0,21,21, 1, 1, 2, 4
BYTE 14, 0,31, 4, 4, 4, 8
BYTE 8, 8, 8,12,10, 8, 8
BYTE 4, 4,31, 4, 4, 8,16
BYTE 0,14, 0, 0, 0, 0,31
BYTE 0,31, 1,10, 4,10,16
BYTE 4,31, 2, 4,14,21, 4
BYTE 2, 2, 2, 2, 2, 4, 8
BYTE 0, 4, 2,17,17,17,17
BYTE 16,16,31,16,16,16,15
BYTE 0,31, 1, 1, 1, 2,12
BYTE 0, 8,20, 2, 1, 1, 0
BYTE 4,31, 4, 4,21,21, 4
BYTE 0,31, 1, 1,10, 4, 2
BYTE 0,14, 0,14, 0,14, 1
BYTE 0, 4, 8,16,17,31, 1
BYTE 0, 1, 1,10, 4,10,16
BYTE 0,31, 8,31, 8, 8, 7
BYTE 8, 8,31, 9,10, 8, 8
BYTE 0,14, 2, 2, 2, 2,31
BYTE 0,31, 1,31, 1, 1,31
BYTE 14, 0,31, 1, 1, 2, 4
BYTE 18,18,18,18, 2, 4, 8
BYTE 0, 4,20,20,21,21,22
BYTE 0,16,16,17,18,20,24
BYTE 0,31,17,17,17,17,31
BYTE 0,31,17,17, 1, 2, 4
BYTE 0,24, 0, 1, 1, 2,28
BYTE 4,18, 8, 0, 0, 0, 0
BYTE 28,20,28, 0, 0, 0, 0
BYTE 0, 0, 9,21,18,18,13 
BYTE 10, 0,14, 1,15,17,15
BYTE 0,14,17,30,17,30,16
BYTE 0, 0,14,16,12,17,14
BYTE 0,17,17,17,19,29,16
BYTE 0, 0,15,20,18,17,14
BYTE 0, 6, 9,17,17,30,16
BYTE 0,15,17,17,17,15, 1
BYTE 0, 0, 7, 4, 4,20, 8
BYTE 2,26, 2, 0, 0, 0, 0
BYTE 2, 0, 6, 2, 2, 2, 2
BYTE 0,20, 8,20, 0, 0, 0
BYTE 4,14,20,21,14, 4, 0
BYTE 8, 8,28, 8,28, 8,15
BYTE 14, 0,22,25,17,17,17
BYTE 10, 0,14,17,17,17,14
BYTE 0,22,25,17,17,30,16
BYTE 0,13,19,17,17,15, 1 
BYTE 14,17,31,17,17,14, 0
BYTE 0, 0, 0, 0,11,21,26 
BYTE 0,14,17,17,10,27, 0
BYTE 10, 0,17,17,17,19,13
BYTE 31,16, 8, 4, 8,16,31
BYTE 0,31,10,10,10,19, 0 
BYTE 31, 0,17,10, 4,10,17
BYTE 0,17,17,17,17,15, 1
BYTE 1,30, 4,31, 4, 4, 0
BYTE 0,31, 8,15, 9,17, 0
BYTE 0,31,21,31,17,17, 0 
BYTE 0, 0, 4, 0,31, 0, 4 
BYTE 0, 0, 0, 0, 0, 0, 0 
BYTE 31,31,31,31,31,31,31